package com.sun.org.apache.bcel.internal.generic;

import com.sun.org.apache.bcel.internal.util.ByteSequence;
import java.io.IOException;
import java.io.DataOutputStream;

public class TABLESWITCH extends Select
{
    TABLESWITCH() {
    }
    
    public TABLESWITCH(int[] match, InstructionHandle[] targets, InstructionHandle defaultTarget) {
        super((short)170, match, targets, defaultTarget);
        short _length = (short)(13 + this.getMatch_length() * 4);
        super.setLength((int)_length);
        this.setFixed_length((int)_length);
    }
    
    @Override
    public void dump(DataOutputStream out) throws IOException {
        super.dump(out);
        int _match_length = this.getMatch_length();
        int low = (_match_length > 0) ? super.getMatch(0) : 0;
        out.writeInt(low);
        int high = (_match_length > 0) ? super.getMatch(_match_length - 1) : 0;
        out.writeInt(high);
        for (int i = 0; i < _match_length; ++i) {
            out.writeInt(this.setIndices(i, this.getTargetOffset(super.getTarget(i))));
        }
    }
    
    @Override
    protected void initFromFile(ByteSequence bytes, boolean wide) throws IOException {
        super.initFromFile(bytes, wide);
        int low = bytes.readInt();
        int high = bytes.readInt();
        int _match_length = high - low + 1;
        this.setMatch_length(_match_length);
        short _fixed_length = (short)(13 + _match_length * 4);
        this.setFixed_length((int)_fixed_length);
        super.setLength((int)(short)(_fixed_length + super.getPadding()));
        super.setMatches(new int[_match_length]);
        super.setIndices(new int[_match_length]);
        super.setTargets(new InstructionHandle[_match_length]);
        for (int i = 0; i < _match_length; ++i) {
            super.setMatch(i, low + i);
            super.setIndices(i, bytes.readInt());
        }
    }
    
    @Override
    public void accept(Visitor v) {
        v.visitVariableLengthInstruction(this);
        v.visitStackConsumer(this);
        v.visitBranchInstruction(this);
        v.visitSelect(this);
        v.visitTABLESWITCH(this);
    }
}
